
##############################################################################################
# This file creates the account definitions for all of the past years - 
# You can adjust which variables are included in the account ownership variable
# here. This is organized by year

# We also need to create identifiers for past years for findex, mobile money, id, and the long findex questionnaire (d/developing)
##############################################################################################


# NOTE: all country spellings must match the latest spellings included in the Prereg data cleaning





####################################################################################################################################################################
# IDENTIFIERS
####################################################################################################################################################################


# need to make sure that no 2022 countries are included in i21 - this was during covid and we re-surveyed because some places were skewed due to phone itnerviews
i22_clist <- c("Viet Nam", "Mexico", "Madagascar", "Botswana", "Ethiopia", "Mauritania", "Niger", "Azerbaijan", "Chad", 
               "Comoros", "Congo, Dem. Rep.", "Guatemala", "Lesotho", "Eswatini", "Gambia, The", "Yemen, Rep.")


# in 2014 there was not a specific mobile money filter question so we need to identify the list of countries that we use

m11_clist  <- c("Afghanistan", "Argentina", "Armenia", "Bangladesh", "Benin", "Bolivia", "Botswana", "Brazil",
                "Burkina Faso", "Burundi", "Cambodia", "Cameroon", "Chad", "Chile", "Colombia", "Congo, Dem. Rep.",
                "Congo, Rep.", "Cote d'Ivoire", "Dominican Republic", "Egypt, Arab Rep.", "El Salvador", "Ethiopia",
                "Gabon", "Ghana", "Guatemala", "Guinea", "Haiti", "Honduras", "India", "Indonesia", "Iran, Islamic Rep.",
                "Jamaica", "Jordan", "Kenya", "Lebanon", "Liberia", "Madagascar", "Malawi", "Malaysia", "Mali",
                "Mauritania", "Mauritius", "Mexico", "Mongolia", "Morocco", "Mozambique", "Myanmar", "Namibia",
                "Nepal", "Nicaragua", "Niger", "Nigeria", "Pakistan", "Panama", "Paraguay", "Peru", "Philippines",
                "Qatar", "Romania", "Rwanda", "Senegal", "Sierra Leone", "Singapore", "Somalia", "South Africa",
                "Sri Lanka", "Tajikistan", "Tanzania", "Thailand", "Togo", "Tunisia", "Turkiye", "Uganda",
                "United Arab Emirates", "Uruguay", "Venezuela, RB", "Viet Nam", "Zambia", "Zimbabwe")


m14_clist <- c("Afghanistan", "Argentina", "Armenia", "Bangladesh", "Benin", "Bolivia", "Botswana", 
               "Brazil", "Burkina Faso", "Burundi", "Cambodia", "Cameroon", "Chad", "Chile", 
               "Colombia", "Congo, Dem. Rep.", "Congo, Rep.", "Cote d'Ivoire", "Dominican Republic", 
               "Egypt, Arab Rep.", "El Salvador", "Ethiopia", "Gabon", "Ghana", "Guatemala", 
               "Guinea", "Haiti", "Honduras", "India", "Indonesia", "Iran, Islamic Rep.", 
               "Jamaica", "Jordan", "Kenya", "Lebanon", "Liberia", "Madagascar", "Malawi", 
               "Malaysia", "Mali", "Mauritania", "Mauritius", "Mexico", "Mongolia", "Morocco", 
               "Mozambique", "Myanmar", "Namibia", "Nepal", "Nicaragua", "Niger", "Nigeria", 
               "Pakistan", "Panama", "Paraguay", "Peru", "Philippines", "Qatar", "Romania", 
               "Rwanda", "Senegal", "Sierra Leone", "Singapore", "Somalia", "South Africa", 
               "Sri Lanka", "Tajikistan", "Tanzania", "Thailand", "Togo", "Tunisia", "Turkiye", 
               "Uganda", "United Arab Emirates", "Uruguay", "Venezuela, RB", "Viet Nam", 
               "Zambia", "Zimbabwe")

# developing countries that were asked full questionnaire
d14_clist <- c(
  "Afghanistan", "Albania", "Algeria", "Angola", "Argentina", "Armenia", "Azerbaijan", 
  "Bangladesh", "Belarus", "Belize", "Benin", "Bhutan", "Bolivia", 
  "Bosnia and Herzegovina", "Botswana", "Brazil", "Bulgaria", "Burkina Faso", "Burundi", 
  "Cambodia", "Cameroon", "Chad", "Chile", "China", "Colombia", "Congo, Dem. Rep.", 
  "Congo, Rep.", "Costa Rica", "Cote d'Ivoire", "Croatia", "Czech Republic", 
  "Dominican Republic", "Ecuador", "Egypt, Arab Rep.", "El Salvador", "Eritrea", 
  "Estonia", "Ethiopia", "Gabon", "Gambia, The", "Georgia", "Ghana", "Greece", 
  "Guatemala", "Guinea", "Haiti", "Honduras", "Hungary", "India", "Indonesia", 
  "Iran, Islamic Rep.", "Iraq", "Israel", "Jamaica", "Jordan", "Kazakhstan", 
  "Kenya", "Kosovo", "Kyrgyz Republic", "Lao PDR", "Latvia", "Lebanon", "Liberia", 
  "Libya", "Lithuania", "Macedonia, FYR", "Madagascar", "Malawi", "Malaysia", 
  "Mali", "Mauritania", "Mauritius", "Mexico", "Moldova", "Mongolia", "Montenegro", 
  "Morocco", "Mozambique", "Myanmar", "Namibia", "Nepal", "Nicaragua", "Niger", 
  "Nigeria", "Pakistan", "Panama", "Paraguay", "Peru", "Philippines", "Poland", 
  "Puerto Rico", "Romania", "Russian Federation", "Rwanda", "Senegal", "Serbia", 
  "Sierra Leone", "Singapore", "Slovak Republic", "Somalia", "South Africa", 
  "South Sudan", "Sri Lanka", "Sudan", "Syrian Arab Republic", "Tajikistan", 
  "Tanzania", "Thailand", "Togo", "Tunisia", "Turkey", "Turkmenistan", "Uganda", 
  "Ukraine", "Uruguay", "Uzbekistan", "Venezuela, RB", "Vietnam", "West Bank and Gaza", 
  "Yemen, Rep.", "Zambia", "Zimbabwe"
)


m17_clist <- c("Afghanistan", "Albania", "Argentina", "Armenia", "Bangladesh", "Benin", "Bolivia", 
               "Botswana", "Brazil", "Burkina Faso", "Cambodia", "Cameroon", "Chad", "Chile", 
               "Colombia", "Congo, Dem. Rep.", "Congo, Rep.", "Cote d'Ivoire", "Dominican Republic", 
               "Ecuador", "Egypt, Arab Rep.", "El Salvador", "Ethiopia", "Gabon", "Georgia", 
               "Ghana", "Guatemala", "Guinea", "Haiti", "Honduras", "India", "Indonesia", 
               "Iran, Islamic Rep.", "Iraq", "Jamaica", "Jordan", "Kenya", "Kyrgyz Republic", 
               "Lesotho", "Liberia", "Madagascar", "Malawi", "Malaysia", "Maldives", "Mali", 
               "Mauritania", "Mauritius", "Mexico", "Mongolia", "Morocco", "Mozambique", "Myanmar", 
               "Namibia", "Nicaragua", "Niger", "Nigeria", "Pakistan", "Panama", "Paraguay", 
               "Peru", "Philippines", "Romania", "Rwanda", "Senegal", "Sierra Leone", "Singapore", 
               "South Africa", "Sri Lanka", "Tanzania", "Thailand", "Togo", "Tunisia", "Turkiye", 
               "Uganda", "United Arab Emirates", "Venezuela, RB", "Viet Nam", "Zambia", "Zimbabwe")

# d is for "developing" meaning that people in this country are asked all variables
d17_clist <- c("Afghanistan", "Albania", "Algeria", "Argentina", "Armenia", "Azerbaijan", "Bangladesh", 
         "Belarus", "Benin", "Bolivia", "Bosnia and Herzegovina", "Botswana", "Brazil", "Bulgaria", 
         "Burkina Faso", "Cambodia", "Cameroon", "Central African Republic", "Chad", "Chile", 
         "China", "Colombia", "Congo, Dem. Rep.", "Congo, Rep.", "Costa Rica", "Croatia", 
         "Czechia", "Cote d'Ivoire", "Dominican Republic", "Ecuador", "Egypt, Arab Rep.", 
         "El Salvador", "Estonia", "Ethiopia", "Gabon", "Georgia", "Ghana", "Greece", "Guatemala", 
         "Guinea", "Haiti", "Honduras", "Hungary", "India", "Indonesia", "Israel", "Jamaica", 
         "Jordan", "Kazakhstan", "Kenya", "Kosovo", "Kyrgyz Republic", "Lao PDR", "Latvia", 
         "Lebanon", "Lesotho", "Liberia", "Lithuania", "Macedonia, FYR", "Madagascar", "Malawi", 
         "Malaysia", "Maldives", "Mali", "Mauritania", "Mexico", "Moldova", "Mongolia", 
         "Montenegro", "Morocco", "Mozambique", "Myanmar", "Namibia", "Nepal", "Nicaragua", 
         "Niger", "Nigeria", "Pakistan", "Panama", "Paraguay", "Peru", "Philippines", "Poland", 
         "Portugal", "Romania", "Rwanda", "Senegal", "Serbia", "Sierra Leone", "Slovak Republic", 
         "Slovenia", "South Africa", "Sri Lanka", "Sudan", "Tajikistan", "Tanzania", "Thailand", 
         "Togo", "Tunisia", "Turkey", "Turkmenistan", "Uganda", "Ukraine", "Uruguay", "Uzbekistan", 
         "Viet Nam", "Zambia", "Zimbabwe")

# NOTE: in 2017 there was a separate ag insurance module - to see which countries were included see "Prereg_Masterdata_Findex17.do"

m21_clist <- c("Afghanistan", "Argentina", "Armenia", "Bangladesh", "Benin", "Bolivia", 
               "Brazil", "Burkina Faso", "Cambodia", "Cameroon", "Colombia", "Congo, Rep.", 
               "Cote d'Ivoire", "Dominican Republic", "Egypt, Arab Rep.", "El Salvador", 
               "Gabon", "Georgia", "Ghana", "Guinea", "Honduras", "India", "Indonesia", 
               "Iran, Islamic Rep.", "Iraq", "Jamaica", "Jordan", "Kenya", "Kyrgyz Republic", 
               "Lao PDR", "Liberia", "Malawi", "Malaysia", "Mali", "Mauritius",
               "Mongolia", "Morocco", "Mozambique", "Myanmar", "Namibia", "Nepal", "Nigeria", 
               "Nicaragua", "Pakistan", "Paraguay", "Peru", "Philippines", "Russian Federation", 
               "Senegal", "Sierra Leone", "Singapore", "South Africa", "South Sudan", 
               "Sri Lanka", "Tajikistan", "Tanzania", "Thailand", "Togo", "Tunisia", 
               "Turkiye", "United Arab Emirates", "Uganda", "Venezuela, RB", 
               "West Bank and Gaza", "Zambia", "Zimbabwe")

d21_clist <- c("Afghanistan", "Albania", "Algeria", "Argentina", "Armenia", "Bangladesh", 
              "Benin", "Bolivia", "Bosnia and Herzegovina", "Brazil", "Bulgaria", 
              "Burkina Faso", "Cambodia", "Cameroon", "Chile", "China", "Colombia", 
              "Congo, Rep.", "Costa Rica", "Cote d'Ivoire", "Croatia", "Czech Republic", 
              "Dominican Republic", "Ecuador", "Egypt, Arab Rep.", "El Salvador", 
              "Estonia", "Gabon", "Georgia", "Ghana", "Greece", "Guinea", "Honduras", 
              "Hungary", "India", "Indonesia", "Iraq", "Israel", "Jamaica", "Jordan", 
              "Kazakhstan", "Kenya", "Kosovo", "Kyrgyz Republic", "Lao PDR", "Latvia", 
              "Lebanon", "Liberia", "Lithuania", "Malawi", "Malaysia", "Mali", 
              "Mauritius", "Moldova", "Mongolia", "Morocco", "Mozambique", 
              "Myanmar", "Namibia", "Nepal", "Nicaragua", "Nigeria", "North Macedonia", 
              "Pakistan", "Panama", "Paraguay", "Peru", "Philippines", "Poland", 
              "Romania", "Russian Federation", "Senegal", "Serbia", "Sierra Leone", 
              "Singapore", "Slovak Republic", "South Africa", "South Sudan", "Sri Lanka", 
              "Tajikistan", "Tanzania", "Thailand", "Togo", "Tunisia", "Turkey", 
              "Uganda", "Ukraine", "Uzbekistan", "Venezuela, RB","Zambia", 
              "Zimbabwe")

id21_clist <- countries <- c("Afghanistan", "Albania", "Algeria", "Argentina", "Armenia", "Austria", 
              "Bangladesh", "Belgium", "Benin", "Bolivia", "Bosnia and Herzegovina", 
              "Brazil", "Bulgaria", "Burkina Faso", "Cambodia", "Cameroon", "Canada", 
              "Chile", "China", "Colombia", "Congo, Rep.", "Costa Rica", "Cote d'Ivoire", 
              "Croatia", "Cyprus", "Czech Republic", "Denmark", "Dominican Republic", 
              "Ecuador", "Egypt, Arab Rep.", "El Salvador", "Estonia", "Finland", 
              "France", "Gabon", "Georgia", "Germany", "Ghana", "Greece", "Guinea", 
              "Honduras", "Hong Kong SAR, China", "Hungary", "Iceland", "Indonesia", 
              "Iran, Islamic Rep.", "Iraq", "Israel", "Italy", "Jamaica", "Japan", 
              "Jordan", "Kazakhstan", "Kenya", "Korea, Rep.", "Kosovo", "Kyrgyz Republic", 
              "Lao PDR", "Latvia", "Lebanon", "Liberia", "Lithuania", "Malaysia", 
              "Malawi", "Mali", "Malta", "Mauritius", "Mexico", "Moldova", "Mongolia", 
              "Morocco", "Mozambique", "Myanmar", "Namibia", "Nepal", "Netherlands", 
              "Nicaragua", "Nigeria", "North Macedonia", "Norway", "Pakistan", 
              "Panama", "Paraguay", "Peru", "Philippines")


m22_clist <- c("Botswana", "Chad", "Comoros", "Congo, Dem. Rep.", "Eswatini", 
                    "Ethiopia", "Gambia, The", "Guatemala", "Lesotho", "Madagascar", 
                    "Mauritania", "Mexico", "Niger", "Viet Nam")

d22_clist <- c("Azerbaijan", "Botswana", "Chad", "Comoros", "Congo, Dem. Rep.", 
               "Eswatini", "Ethiopia", "Gambia, The", "Guatemala", "Lesotho", 
               "Madagascar", "Mauritania", "Mexico", "Niger", "Viet Nam", "Yemen, Rep.")


id22_clist <- c("Azerbaijan", "Botswana", "Chad", "Comoros", "Congo, Dem. Rep.", 
               "Eswatini", "Ethiopia", "Gambia, The", "Guatemala", "Lesotho", 
               "Madagascar", "Mauritania", "Mexico", "Niger", "Vietnam", "Yemen, Rep.")




dataframe_2024 <- dataframe_2024 %>%
  mutate(i11 = ifelse(!is.na(wp11623) & year == 2011, 1, NA),
         i14 = ifelse(!is.na(wp14887) & wave10 == 91 & year == 2014, 1, NA),
         i17 = ifelse(!is.na(wp19548) & wave10 %in% c(121, 122, 129) & year ==  2017, 1, NA),
         i21 = ifelse(!is.na(wp19548) & wave10 %in% c(161, 162, 163) & year ==  2021 & !countrynewwb %in% i22_clist, 1, NA), # make sure to exclude i22 countries that might have 2021 data
         i22 = ifelse(!is.na(wp19548) & wave10 %in% c(171, 172) & year ==  2022, 1, NA),
         i21_22 = ifelse(i21 == 1 | i22 == 1, 1, NA), # create a combined 21 and 22 identifier because they are now the same wave
         
         m11 = ifelse(!is.na(wp14887) & i11 == 1 & countrynewwb %in% m11_clist, 1, NA),
         m14 = ifelse(!is.na(wp14887) & i14 == 1 & countrynewwb %in% m14_clist, 1, NA), # note that this was originally just "M" in old stata
         m17 = ifelse(!is.na(wp19548) & i17 == 1 & countrynewwb %in% m17_clist, 1, NA),
         m21 = ifelse(!is.na(wp19548) & i21 == 1 & countrynewwb %in% m21_clist, 1, NA),
         m22 = ifelse(!is.na(wp19548) & i22 == 1& countrynewwb %in% m22_clist, 1, NA),
         m21_22 = ifelse(m21 == 1 | m22 == 1, 1, NA), # create a combined 21 and 22 identifier because they are now the same wave
         
         d14 = ifelse(!is.na(wp14887) & i14 == 1 & countrynewwb %in% d14_clist, 1, NA),
         d17 = ifelse(!is.na(wp19548) & i17 == 1 & countrynewwb %in% d17_clist, 1, NA),
         d21 = ifelse(!is.na(wp19548) & i21 == 1 & countrynewwb %in% d21_clist, 1, NA),
         d22 = ifelse(!is.na(wp19548) & i22 == 1 & countrynewwb %in% d22_clist, 1, NA),
         d21_22 = ifelse(d21 == 1 | d22 == 1, 1, NA),
         
         # ID data starts in 2021
         id21 = ifelse(!is.na(wp19548) & !is.na(wp21399) & i21 == 1 & countrynewwb %in% id21_clist, 1, NA),
         id22 = ifelse(!is.na(wp19548) & !is.na(wp21399) & i22 == 1 & countrynewwb %in% id22_clist, 1, NA),
         id21_22 = ifelse(id21 == 1 | id22 == 1, 1, NA))



####################################################################################################################################################################
# VARIABLES
####################################################################################################################################################################

###########################################
# 2021/22
###########################################

# Correct for filter question for mobile money
dataframe_2024 <- dataframe_2024 %>%
  mutate(wp19480c = ifelse(wp19479 != 1 & wp19480 == 1, 2, wp19480))

# Create global variables for groups of variables
a2021_1a <- c("wp19548", "wp14888", "wp19516", "wp19508", "wp19523")
a2021_1b <- c("wp21389", "wp21385", "wp21393")
a2021_1c <- c("wp19504")
a2021_2a <- c("wp19480c") # this includes the fin12 filter
a2021_2a_nf <- c("wp19480") # Fin13 - no filter for Fin12
a2021_2b <- c("wp19517", "wp19509", "wp19524")
a2021_2c <- c("wp19505")

# 2021/22 account at a financial institution
dataframe_2024 <- dataframe_2024 %>%
  # mutate(across(all_of(a2021_1a), ~ ifelse(i21_22 == 1, ifelse(. == 1, 1, 0), 0), .names = "i1_21_{col}")) %>%
  mutate(d1_1 = case_when(wp19548 == 1 & i21_22 == 1 ~ 1, 
                          i21_22 == 1 ~ 0,
                          TRUE ~ NA), #account at financial institution 
          d1_2 = if_else(wp14888 == 1 & !is.na(i21_22), 1, d1_1), #debit card: own - THIS IS THE BASELINE ACCOUNT OWNERSHIP NUMBER!!
          d1_3 = case_when(wp19516 == 1 & !is.na(i21_22) ~ 1, 
                           !is.na(i21_22) ~ d1_2,
                           TRUE ~ NA), #payment into account; transfers
          d1_4 = case_when(wp19508 == 1 & !is.na(i21_22) ~ 1, 
                           !is.na(i21_22) ~ d1_3,
                           TRUE ~ NA), #payment into account; wages 
          d1_5 = case_when(wp19523 == 1 & !is.na(i21_22) ~ 1, 
                           !is.na(i21_22) ~ d1_4,
                           TRUE ~ NA), #payment into account; agr. revenue
          d1_6 = case_when(wp21389 == 1 & !is.na(i21_22) ~ 1, 
                           !is.na(i21_22) ~ d1_5,
                           TRUE ~ NA), #payment into a card; benefits
          d1_7 = case_when(wp21385 == 1 & !is.na(i21_22) ~ 1, 
                           !is.na(i21_22) ~ d1_6,
                           TRUE ~ NA), #payment into a card; wages
          d1_8 = case_when(wp19504 == 1 & !is.na(i21_22) ~ 1, 
                           !is.na(i21_22) ~ d1_7,
                           TRUE ~ NA), #payment from account; utility
          d1_9 = case_when(wp21393 == 1 & !is.na(i21_22) ~ 1, 
                           !is.na(i21_22) ~ d1_8,
                           TRUE ~ NA)) #payment into card; ag.



# 2021 mobile account
dataframe_2024 <- dataframe_2024 %>%
  # mutate(across(all_of(a2021_2a), ~ ifelse(i21_22 == 1 & m21 == 1, ifelse(. == 1, 1, 0), 0), .names = "i2_21_{col}")) %>%
  mutate(d2_1 = case_when(wp19480c == 1 & m21_22 == 1 ~ 1, 
                   m21_22 == 1 ~ 0,
                   TRUE ~ NA), #account at financial institution 
         d2_2 = case_when(wp19517 == 1 & m21_22 == 1 ~ 1, 
                          m21_22 == 1 ~ d2_1),
         d2_3 = case_when(wp19509 == 1 & m21_22 == 1 ~ 1, 
                          m21_22 == 1 ~ d2_2),
         d2_4 = case_when(wp19524 == 1 & m21_22 == 1 ~ 1, 
                          m21_22 == 1 ~ d2_3),
         d2_5 = case_when(wp19505 == 1 & m21_22 == 1 ~ 1, 
                          m21_22 == 1 ~ d2_4))


# Generating the account ownership variables

# Create metrics for financial inclusion in 2021/22
fi_var_list <- c(a2021_1a, a2021_1b, a2021_1c)
mm_var_list <- c(a2021_2a, a2021_2b)

dataframe_2024 <- dataframe_2024 %>%
  mutate(
    acc21_22fin = case_when(
      i21_22 == 1 & rowSums(across(all_of(fi_var_list)) == 1, na.rm = TRUE) > 0 ~ 1,
      i21_22 == 1 & rowSums(across(all_of(fi_var_list)) == 1, na.rm = TRUE) == 0 ~ 0,
      TRUE ~ NA
    ),
    acc21_22mob = case_when(
      m21_22 == 1 & rowSums(across(all_of(mm_var_list)) == 1, na.rm = TRUE) > 0 ~ 1,
      m21_22 == 1 & rowSums(across(all_of(mm_var_list)) == 1, na.rm = TRUE) == 0 ~ 0,
      TRUE ~ NA
    ),
    acc21_22any = case_when(
      acc21_22fin == 1 | acc21_22mob == 1 ~ 1,
      acc21_22fin != 1 & acc21_22mob != 1 & m21_22 == 1 ~ 0,
      acc21_22fin != 1 & i21_22 == 1 ~ 0,
      TRUE ~ NA
    ),
    unbanked21_22 = case_when(
      acc21_22any == 0 ~ 1,
      acc21_22any == 1 ~ 0,
      TRUE ~ NA
    ),
    # create the ONLY and BOTH variables
    acc21_22fin_o = case_when(m21_22 == 1 & acc21_22fin == 1 & acc21_22mob != 1 ~ 1,
                              is.na(m21_22) & acc21_22fin == 1 ~ 1,
                              i21_22 == 1 ~ 0,
                              TRUE ~ NA),
    acc21_22mob_o = case_when(m21_22 == 1 & acc21_22fin != 1 & acc21_22mob == 1 ~ 1,
                              m21_22 == 1 ~ 0,
                              TRUE ~ NA),
    acc21_22any_b = case_when(m21_22 == 1 & acc21_22fin == 1 & acc21_22mob == 1 ~ 1,
                              m21_22 == 1 ~ 0,
                              TRUE ~ NA))


# NO FILTER FOR FIN12!!! - nf stands for no filter
mm_var_list2 <- c(a2021_2a_nf, a2021_2b)

dataframe_2024 <- dataframe_2024 %>%
  mutate(
    acc21_22mob_nf = case_when(
      m21_22 == 1 & rowSums(across(all_of(mm_var_list2)) == 1, na.rm = TRUE) > 0 ~ 1,
      m21_22 == 1 & rowSums(across(all_of(mm_var_list2)) == 1, na.rm = TRUE) == 0 ~ 0,
      TRUE ~ NA
    ),
    acc21_22any_nf = case_when(
      acc21_22fin == 1 | acc21_22mob_nf == 1 ~ 1,
      acc21_22fin != 1 & acc21_22mob_nf != 1 & m21_22 == 1 ~ 0,
      acc21_22fin != 1 & i21_22 == 1 ~ 0,
      TRUE ~ NA
    ))


###########################################
# 2017
###########################################


# Assuming the dataset is named dataframe_2024 and i17 is a column in the dataset

# 2017 account at a financial institution
a2017_1a <- c("wp19548", "wp14889", "wp19516", "wp19508", "wp19523")
a2017_1b <- c("wp19530")
a2017_1c <- c("wp19519", "wp19511")
a2017_1d <- c("wp19533")
a2017_1e <- c("wp19504")
a2017_1f <- c("wp19495", "wp19500")

# Generate i1 variables
# dataframe_2024 <- dataframe_2024 %>%
#   mutate(across(all_of(c(a2017_1a, a2017_1b, a2017_1c, a2017_1d, a2017_1e, a2017_1f)), 
#                 ~ ifelse(i17 == 1 & . == 1, 1, 0), 
#                 .names = "i1_{col}"))

# Generating c1_* variables
dataframe_2024 <- dataframe_2024 %>%
  mutate(
    c1_1 = ifelse(i17 == 1, wp19548, NA),                      # acc at fin inst
    c1_2 = ifelse(wp14889 == 1 & i17 == 1, 1, c1_1),   # debit card in own name
    c1_3 = ifelse(wp19516 == 1 & i17 == 1, 1, c1_2),   # into account: transfers
    c1_4 = ifelse(wp19508 == 1 & i17 == 1, 1, c1_3),   # into account: wages
    c1_5 = ifelse(wp19523 == 1 & i17 == 1, 1, c1_4),   # into account: agr. revenue
    c1_6 = ifelse(wp19519 == 1 & i17 == 1, 1, c1_5),   # into card: transfers
    c1_7 = ifelse(wp19511 == 1 & i17 == 1, 1, c1_6),   # into card: wages
    c1_8 = ifelse(wp19504 == 1 & i17 == 1, 1, c1_7),   # from account: payments utility
    c1_9 = ifelse(wp19481 == 1 & i17 == 1, 1, c1_8),   # used mobile/internet to make payment
    c1_10 = ifelse(wp19530 == 1 & i17 == 1, 1, c1_9),  # into account: self-employment
    c1_11 = ifelse(wp19533 == 1 & i17 == 1, 1, c1_10), # into card: self-employment
    c1_12 = ifelse(wp19495 == 1 & i17 == 1, 1, c1_11), # remittances sent
    c1_13 = ifelse(wp19500 == 1 & i17 == 1, 1, c1_12)  # remittances received
  )

# 2017 mobile account variables
a2017_2a <- c("wp19480")
a2017_2b <- c("wp19517", "wp19509", "wp19524")
a2017_2c <- c("wp19531")
a2017_2d <- c("wp19505")
a2017_2e <- c("wp19496", "wp19501")


# Generating c2_* variables
dataframe_2024 <- dataframe_2024 %>%
  mutate(
    c2_1 = ifelse(i17 == 1, wp19480, NA),                                # GSMA
    c2_2 = ifelse(wp19517 == 1 & m17 == 1, 1, c2_1),  # into mobile: transfers
    c2_3 = ifelse(wp19509 == 1 & m17 == 1, 1, c2_2),  # into mobile: wages
    c2_4 = ifelse(wp19524 == 1 & m17 == 1, 1, c2_3),  # into mobile: agr. revenue
    c2_5 = ifelse(wp19531 == 1 & m17 == 1, 1, c2_4),  # into mobile: self employment
    c2_6 = ifelse(wp19505 == 1 & m17 == 1, 1, c2_5),  # from mobile: payments utility
    c2_7 = ifelse(wp19496 == 1 & m17 == 1, 1, c2_6),  # remittances sent
    c2_8 = ifelse(wp19501 == 1 & m17 == 1, 1, c2_7)   # remittances received
  )

# Create metrics for financial inclusion in 2017
fi_var_list <- c(a2017_1a, a2017_1c, a2017_1e)
mm_var_list <- c(a2017_2a, a2017_2b)

dataframe_2024 <- dataframe_2024 %>%
  mutate(
    acc17fin = case_when(
      (i17 == 1) & rowSums(across(all_of(fi_var_list)) == 1, na.rm = TRUE) > 0 ~ 1,
      (year == 2017) & countrynewwb == "China" & (wp19481 == 1 | (wp19482 == 1 & wp19483 == 1)) ~ 1,  #NOTE!!!!! 
      (i17 == 1) & rowSums(across(all_of(fi_var_list)) == 1, na.rm = TRUE) == 0 ~ 0,
      
      TRUE ~ NA
    ),
    acc17mob = case_when(
      (m17 == 1) & rowSums(across(all_of(mm_var_list)) == 1, na.rm = TRUE) > 0 ~ 1,
      (m17 == 1) & rowSums(across(all_of(mm_var_list)) == 1, na.rm = TRUE) == 0 ~ 0,
      TRUE ~ NA
    ),
    acc17any = case_when(
      acc17fin == 1 | acc17mob == 1 ~ 1,
      acc17fin != 1 & acc17mob != 1 & (m17 == 1) ~ 0,
      acc17fin != 1 & (i17 == 1) ~ 0,
      TRUE ~ NA
    ),
    unbanked17 = case_when(
      acc17any == 0 ~ 1,
      acc17any == 1 ~ 0,
      TRUE ~ NA
    ),
    # create the ONLY and BOTH variables
    
    acc17fin_o = case_when(m17 == 1 & acc17fin == 1 & acc17mob != 1 ~ 1,
                              is.na(m17) & acc17fin == 1 ~ 1,
                              i17 == 1 ~ 0,
                              TRUE ~ NA),
    acc17mob_o = case_when(m17 == 1 & acc17fin != 1 & acc17mob == 1 ~ 1,
                              m17 == 1 ~ 0,
                              TRUE ~ NA),
    acc17any_b = case_when(m17 == 1 & acc17fin == 1 & acc17mob == 1 ~ 1,
                              m17 == 1 ~ 0,
                              TRUE ~ NA))



###########################################
# 2014
###########################################

# This is inefficient but to maintain a similar story between the old stata code and this I am writing out the code in the way it was done earlier

dataframe_2024 <- dataframe_2024 %>%
  mutate(
    # this used to be coded as wp14887_7d
    acc14fin = case_when(i14 == 1 & (wp14887 == 1 | wp14889 == 1 | wp15179 == 1 | 
                                     wp14947 == 1 | wp15180 == 1 | wp14948 == 1 |
                                     wp15186 == 1 | wp14942 == 1 | wp15174 == 1) ~ 1, 
                         i14 == 1 ~ 0, 
                        TRUE ~ NA),
    # formerly coded as wp15163_4d 
    acc14mob = case_when(i14 == 1 & m14 == 1 & (wp15163 == 1 | wp15181 == 1 | wp14949 == 1 | wp15187 == 1) ~ 1, 
                         i14 == 1 & m14 == 1 ~ 0,
                         TRUE ~ NA),
    # acc14mob = ifelse(i14 == 1 & m14 == 1 & (wp15163 == 1 | wp15181 == 1 | wp14949 == 1 | wp15187 == 1), 1, 
    #                     ifelse(i14 == 1 & m14 == 1, 0, NA)),
    acc14any = case_when( # formerly coded as wp14887_ad 
      acc14fin == 1 | acc14mob == 1 ~ 1,
      acc14fin != 1 & acc14mob != 1 & (m14 == 1) ~ 0,
      acc14fin != 1 & (i14 == 1) ~ 0,
      TRUE ~ NA),
    # create the ONLY and BOTH variables
    # acc14fin_o = ifelse(i14 == 1, ifelse(acc14fin == 1 & acc14mob != 1, 1, 0), NA),
    # acc14mob_o = ifelse(i14 == 1 & m14 == 1, ifelse(acc14fin != 1 & acc14mob == 1, 1, 0), NA),
    # acc14any_b = ifelse(i14 == 1 & m14 == 1, ifelse(acc14fin == 1 & acc14mob == 1, 1, 0), NA))
    acc14fin_o = case_when(m14 == 1 & acc14fin == 1 & acc14mob != 1 ~ 1,
                              is.na(m14) & acc14fin == 1 ~ 1,
                              i14 == 1 ~ 0,
                              TRUE ~ NA),
    acc14mob_o = case_when(m14 == 1 & acc14fin != 1 & acc14mob == 1 ~ 1,
                              m14 == 1 ~ 0,
                              TRUE ~ NA),
    acc14any_b = case_when(m14 == 1 & acc14fin == 1 & acc14mob == 1 ~ 1,
                              m14 == 1 ~ 0,
                              TRUE ~ NA))

###########################################
# 2011
###########################################

dataframe_2024 <- dataframe_2024 %>%
  mutate(
    acc11fin = case_when(i11 == 1 & (wp11623 == 1 |  # FI 
                                       wp11624 == 1 | # Post office
                                       wp11626 == 1 | # debit card
                                       wp11667 == 1) ~ 1, # save at a MFI
                         i11 == 1 ~ 0,
                         TRUE ~ NA),
    # RECODE FOR BANGLADESH: we exclude MFI savings from Bangladesh for 2011 because of data discrepancies
    acc11fin = ifelse(countrynewwb == "Bangladesh" & i11 == 1 & wp11623 != 1 & wp11624 != 1 & wp11626 != 1 & acc11fin == 1, 0, acc11fin),
    # NO MOBILE MONEY WAS ASKED IN 2011 - look at Prereg_Masterdata do file and Prereg_MasterData_Findex14v2 to see former construction
    acc11any = case_when(i11 == 1 & acc11fin == 1 ~ 1,
                         i11 == 1 ~ 0,
                         TRUE ~ NA),
    # because no MM, all people who answer yes to having an account only have an FI account
    acc11fin_o = case_when(acc11fin == 1 ~ 1,
                              i11 == 1 ~ 0,
                              TRUE ~ NA))


