
# This file excludes countries from the data 

# this is partially done in 

gallup_data <- gallup_data %>%
  # Disputed territories
  filter(!countrynewwb %in% c("North Cyprus",
                              "Nagorno Karabakh")) %>%
  # all were excluded due to data issues
  filter(!(countrynewwb %in% c("Mozambique", 
                              "Somalia", 
                              "Tunisia", 
                              "Morocco") & year == 2011)) %>%
  # all were excluded due to data issues
  filter(!(countrynewwb %in% c("Liberia",
                              "South Sudan",
                              "Paraguay",
                              "Turkmenistan",
                              # "Algeria", NOTE!!!!! This was added but commented out in the 2017 exclusions.do file
                              "Morocco",
                              "Qatar") & year == 2014)) %>%
  # all were excluded due to data issues
  filter(!(countrynewwb %in% c("Jamaica", 
                              "Yemen, Rep.") & year == 2017)) %>%
  # NOTE: In 2021, because of the lingering effects of covid, some countries were surveyed by phone - 
  # tese numbers ended up being wrong so these countries were re-surveyed in 2022 - they're accounted for in the identifier file but also excluded here
  filter(!(countrynewwb %in% c("Viet Nam", 
                              "Mexico", 
                              "Madagascar", 
                              "Botswana", 
                              "Ethiopia", 
                              "Mauritania", 
                              "Niger", 
                              "Azerbaijan", 
                              "Chad", 
                              "Comoros", 
                              "Congo, Dem. Rep.", 
                              "Guatemala", 
                              "Lesotho", 
                              "Eswatini", 
                              "Gambia, The", 
                              "Yemen, Rep.") & year == 2021)) %>%
  filter(!(countrynewwb %in% c("Myanmar") & year == 2024))
