##############################################################################################
# This file creates the account definitions for all of the INTER-YEAR data
# You can adjust which variables are included in the account ownership variable
# here. This is organized by year and starts with 2015


# NOTE: all country spellings must match the latest spellings included in the Prereg data cleaning - you will have to update

# also, if you are enterprising, you could probably user for loops to generate this data

############
# 2015
############

m15_list <- c("Afghanistan", "Argentina", "Armenia", "Bangladesh", "Benin", "Bolivia", "Botswana", "Brazil", 
         "Burkina Faso", "Cambodia", "Cameroon", "Chad", "Chile", "Colombia", "Congo, Dem. Rep.",
         "Congo, Rep.", "Cote d'Ivoire", "Dominican Republic", "Ecuador", "Egypt, Arab Rep.",
         "El Salvador", "Ethiopia", "Gabon", "Georgia", "Ghana", "Guatemala", "Guinea",
         "Haiti", "Honduras", "India", "Indonesia", "Iran, Islamic Rep.", "Jordan", "Kenya",
         "Liberia", "Madagascar", "Malawi", "Malaysia", "Mali", "Mauritania", "Mexico",
         "Mongolia", "Morocco", "Mozambique", "Myanmar", "Nepal", "Nicaragua", "Niger",
         "Nigeria", "Pakistan", "Panama", "Peru", "Philippines", "Romania", "Rwanda",
         "Senegal", "Sierra Leone", "Singapore", "Somalia", "South Africa", "Sri Lanka",
         "Tanzania", "Thailand", "Togo", "Tunisia", "Turkiye", "Uganda", "United Arab Emirates",
         "Venezuela, RB", "Viet Nam", "Zambia", "Zimbabwe")

############
# 2016
############

m16_list <- c("Afghanistan", "Albania", "Argentina", "Armenia", "Bahrain", "Bangladesh", "Benin",
         "Bolivia", "Botswana", "Brazil", "Burkina Faso", "Cambodia", "Cameroon", "Chad",
         "Chile", "Colombia", "Congo, Dem. Rep.", "Congo, Rep.", "Cote d'Ivoire",
         "Dominican Republic", "Ecuador", "Egypt, Arab Rep.", "El Salvador", "Ethiopia",
         "Gabon", "Georgia", "Ghana", "Guatemala", "Guinea", "Haiti", "Honduras",
         "India", "Indonesia", "Iran, Islamic Rep.", "Iraq", "Jordan", "Kenya",
         "Kyrgyz Republic", "Lesotho", "Liberia", "Madagascar", "Malawi", "Mali",
         "Mauritania", "Mauritius", "Mexico", "Mongolia", "Morocco", "Myanmar",
         "Nepal", "Nicaragua", "Niger", "Nigeria", "Pakistan", "Panama", "Peru",
         "Philippines", "Romania", "Rwanda")

############
# 2018
############
# 
# i18_list <-  c("Afghanistan", "Argentina", "Armenia", "Bangladesh", "Benin", 
#            "Bolivia", "Botswana", "Brazil", "Burkina Faso", "Burundi", 
#            "Cambodia", "Cameroon", "Chad", "Chile", "Colombia", 
#            "Congo, Rep.", "Cote d'Ivoire", "Dominican Republic", 
#            "Ecuador", "Egypt, Arab Rep.", "El Salvador", "Ethiopia", 
#            "Gabon", "Gambia, The", "Ghana", "Guatemala", "Guinea", 
#            "Haiti", "Honduras", "India", "Indonesia", "Iran, Islamic Rep.", 
#            "Iraq", "Jordan", "Kenya", "Kyrgyz Republic", "Liberia", 
#            "Madagascar", "Malawi", "Malaysia", "Mali", "Mauritania", 
#            "Mauritius", "Mexico", "Mongolia", "Morocco", "Mozambique", 
#            "Myanmar", "Namibia", "Nepal", "Nicaragua", "Niger", 
#            "Nigeria", "Pakistan", "Panama", "Paraguay", "Peru", 
#            "Philippines", "Romania", "Rwanda", "Senegal", "Sierra Leone", 
#            "Singapore", "South Africa", "Sri Lanka", "Eswatini", 
#            "Tanzania", "Thailand", "Togo", "Tunisia", "Turkiye", 
#            "Uganda", "United Arab Emirates", "Venezuela, RB", 
#            "Viet Nam", "Zambia", "Zimbabwe")

m18_list <- c("Afghanistan", "Argentina", "Armenia", "Bangladesh", "Benin", 
                     "Bolivia", "Botswana", "Brazil", "Burkina Faso", "Burundi", 
                     "Cambodia", "Cameroon", "Chad", "Chile", "Colombia", 
                     "Congo, Rep.", "Cote d'Ivoire", "Dominican Republic", 
                     "Ecuador", "Egypt, Arab Rep.", "El Salvador", "Ethiopia", 
                     "Gabon", "Gambia, The", "Ghana", "Guatemala", "Guinea", 
                     "Haiti", "Honduras", "India", "Indonesia", "Iran, Islamic Rep.", 
                     "Iraq", "Jordan", "Kenya", "Kyrgyz Republic", "Liberia", 
                     "Madagascar", "Malawi", "Malaysia", "Mali", "Mauritania", 
                     "Mauritius", "Mexico", "Mongolia", "Morocco", "Mozambique", 
                     "Myanmar", "Namibia", "Nepal", "Nicaragua", "Niger", 
                     "Nigeria", "Pakistan", "Panama", "Paraguay", "Peru", 
                     "Philippines", "Romania", "Rwanda", "Senegal", "Sierra Leone", 
                     "Singapore", "South Africa", "Sri Lanka", "Eswatini", 
                     "Tanzania", "Thailand", "Togo", "Tunisia", "Turkiye", 
                     "Uganda", "United Arab Emirates", "Venezuela, RB", 
                     "Viet Nam", "Zambia", "Zimbabwe")


############
# 2019
############

# Define the countries for m19 - i19 is just all countries that aren't missing for fin1

m19_list<- c(
  "Afghanistan", "Argentina", "Armenia", "Bangladesh", "Belarus", "Benin",
  "Bolivia", "Botswana", "Brazil", "Burkina Faso", "Cambodia", "Cameroon",
  "Chad", "Chile", "Colombia", "Congo, Rep.", "Cote d'Ivoire",
  "Dominican Republic", "El Salvador", "Egypt, Arab Rep.", "Ethiopia", "Eswatini",
  "Gabon", "Gambia, The", "Ghana", "Guatemala", "Guinea", "Honduras",
  "India", "Indonesia", "Iran, Islamic Rep.", "Iraq", "Jamaica", "Jordan",
  "Kenya", "Kyrgyz Republic", "Lesotho", "Liberia", "Madagascar", "Malawi",
  "Malaysia", "Mali", "Mauritania", "Mauritius", "Mexico", "Mongolia",
  "Morocco", "Mozambique", "Myanmar", "Namibia", "Nepal", "Nicaragua",
  "Niger", "Nigeria", "Pakistan", "Panama", "Paraguay", "Peru",
  "Philippines", "Romania", "Russian Federation", "Rwanda", "Senegal", "Sierra Leone",
  "Singapore", "South Africa", "Sri Lanka", "Tanzania", "Thailand", "Togo",
  "Tunisia", "Uganda", "United Arab Emirates", "Venezuela, RB", "Viet Nam", "Zambia",
  "Zimbabwe"
)


############
# 2020
############

m20_list <- c("Argentina", "Bangladesh", "Benin", "Bolivia", "Brazil", "Burkina Faso", "Cambodia", 
         "Cameroon", "Colombia", "Congo, Rep.", "Cote d'Ivoire", "Dominican Republic",
         "Egypt, Arab Rep.", "El Salvador", "Ethiopia", "Gabon", "Ghana", "Guinea",
         "India", "Indonesia", "Iran, Islamic Rep.", "Iraq", "Jamaica", "Jordan",
         "Kenya", "Kyrgyz Republic", "Malaysia", "Mali", "Mauritius", "Mexico",
         "Mongolia", "Morocco", "Myanmar", "Namibia", "Nepal", "Nicaragua",
         "Nigeria", "Pakistan", "Paraguay", "Peru", "Philippines", "Romania",
         "Russian Federation", "Senegal", "South Africa", "Sri Lanka", "Tajikistan",
         "Tanzania", "Thailand", "Tunisia", "Turkiye", "Uganda", "United Arab Emirates",
         "Venezuela, RB", "Viet Nam", "Zambia", "Zimbabwe")

# 2020 had an extended survey

e20_list <- c("Albania", "Algeria", "Argentina", "Bangladesh", "Benin", "Bolivia", "Bosnia and Herzegovina",
         "Brazil", "Bulgaria", "Burkina Faso", "Cambodia", "Cameroon", "Chile", "China",
         "Colombia", "Congo, Rep.", "Costa Rica", "Cote d'Ivoire", "Croatia", "Czechia",
         "Dominican Republic", "Ecuador", "Egypt, Arab Rep.", "El Salvador", "Estonia",
         "Ethiopia", "Gabon", "Georgia", "Ghana", "Greece", "Guinea", "Hungary",
         "India", "Indonesia", "Iraq", "Israel", "Jamaica", "Jordan", "Kazakhstan",
         "Kenya", "Kosovo", "Kyrgyz Republic", "Lao PDR", "Latvia", "Lebanon",
         "Lithuania", "Malaysia", "Mali", "Mexico", "Moldova", "Mongolia", "Montenegro",
         "Morocco", "Myanmar", "Namibia", "Nepal", "Nicaragua", "Nigeria")

############
# 2022
############
# NOTE: Some countries were OFFICIALLY SURVEYED in 2022 as part of the 2021 round of the survey due to the pandemic - this list is the inter-year data

m22_s_list <- c("Bangladesh", "Brazil", "Colombia", "Cote d'Ivoire", "Egypt, Arab Rep.",
                          "India", "Indonesia", "Kenya", "Morocco", "Mozambique",
                          "Myanmar", "Nigeria", "Pakistan", "Peru", "Philippines",
                          "South Africa", "Tanzania", "Turkiye", "Uganda", "Zambia")

############
# 2023
############
m23_s_list <- c("Bangladesh", "Brazil", "Colombia", "Congo, Dem. Rep.", "Cote d'Ivoire",
               "Egypt, Arab Rep.", "Ethiopia", "India", "Indonesia", "Kenya",
               "Mexico", "Morocco", "Mozambique", "Myanmar", "Nigeria",
               "Pakistan", "Peru", "Philippines", "South Africa", "Tanzania",
               "Turkiye", "Viet Nam", "Zambia")

# code the identifiers using the waves and country lists defined above

dataframe_2024 <- dataframe_2024 %>%
  mutate(i15 = ifelse(!is.na(wp15845) & wave10 == 101, 1, NA),
         i16 = ifelse(!is.na(wp15845) & wave10 == 111, 1, NA),
         i18 = ifelse(!is.na(wp15845) & wave10 %in% c(131, 132) & year == 2018, 1, NA), # not sure why this code was longer
         i19 = ifelse(!is.na(wp15845) & wave10 == 141, 1, NA),
         i20 = ifelse(!is.na(wp15845) & wave10 %in% c(151, 152, 153, 154, 159), 1, NA),
         i22_s = ifelse(!is.na(wp15845) & wave10 %in% c(171, 172), 1, NA),
         i23_s = ifelse(!is.na(wp15845) & wave10 %in% c(181, 182), 1, NA),
         
         m15 = ifelse(i15 == 1 & countrynewwb %in% c(m15_list), 1, NA),
         m16 = ifelse(i16 == 1 & countrynewwb %in% c(m16_list), 1, NA),
         m18 = ifelse(i18 == 1 & countrynewwb %in% c(m18_list), 1, NA),
         m19 = ifelse(i19 == 1 & countrynewwb %in% c(m19_list), 1, NA),
         m20 = ifelse(i20 == 1 & countrynewwb %in% c(m20_list), 1, NA),
         m22_s = ifelse(i22_s == 1 & countrynewwb %in% c(m22_s_list), 1, NA),
         m23_s = ifelse(i23_s == 1 & countrynewwb %in% c(m23_s_list), 1, NA),
         
         e20 = ifelse(i20 == 1 & countrynewwb %in% c(e20_list), 1, NA)) %>% # this is the "extended 2020 questionnaire - there were no additional notes about this in the original STATA
    

####################################
# ACCOUNT OWNERSHIP - inter-year
####################################

# NOTE: because of case studies that are added in official Findex years, we cannot directly compare these numbers to those that we publish!

  mutate(
        # 2016
        x15_fi = case_when(i15 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1, # account at a fiancial institution OR have a debit card
                           i15 == 1 ~ 0,
                           TRUE ~ NA),
        x15_mob = case_when(m15 == 1 & wp15847 == 1 ~ 1,
                            m15 == 1 ~ 0,
                            TRUE ~ NA),
        x15_any = case_when(i15 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1,
                            m15 == 1 & wp15847 == 1 ~ 1,
                            i15 == 1 ~ 0,
                            TRUE ~ NA),
        # 2016
        x16_fi = case_when(i16 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1, # account at a fiancial institution OR have a debit card
                           i16 == 1 ~ 0,
                           TRUE ~ NA),
        x16_mob = case_when(m16 == 1 & wp15847 == 1 ~ 1, #wp15847 is MM w/o the filter, wp18175 is WITH the filter
                            m16 == 1 & wp18175 == 1 ~ 1, # Note that all data past 2016 only looks at this and not the w/o filter - not sure why non-filter is included here
                            m16 == 1 ~ 0,
                            TRUE ~ NA),
        x16_any = case_when(i16 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1,
                            m16 == 1 & wp15847 == 1 ~ 1, 
                            m16 == 1 & wp18175 == 1 ~ 1,
                            i16 == 1 ~ 0,
                            TRUE ~ NA),
    
        # 2018
         x18_fi = case_when(i18 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1, # account at a fiancial institution OR have a debit card
                            i18 == 1 ~ 0,
                            TRUE ~ NA),
         x18_China = case_when(i18 == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1, # any wechat etc.
                               i18 == 1 & countrynewwb == "China" ~ 0,
                               TRUE ~ NA),
         x18_mob = case_when(m18 == 1 & wp18175 == 1 ~ 1,
                             i18 == 1 & x18_China == 1 & countrynewwb == "China" ~ 1,
                             i18 == 1 & countrynewwb == "China" ~ 0,
                             m18 == 1 ~ 0,
                             TRUE ~ NA),
         x18_any = case_when(i18 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1,
                             i18 == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1,
                             i18 == 1 & countrynewwb == "China" ~ 0,
                             m18 == 1 & wp18175 == 1 ~ 1,
                             i18 == 1 ~ 0,
                             TRUE ~ NA),
         
         # 2019
         x19_fi = case_when(i19 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1, # account at a fiancial institution OR have a debit card
                            i19 == 1 ~ 0,
                            TRUE ~ NA),
         x19_China = case_when(i19 == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1, # any wechat etc.
                               i19 == 1 & countrynewwb == "China" ~ 0,
                               TRUE ~ NA),
         x19_mob = case_when(m19 == 1 & wp18175 == 1 ~ 1,
                             i19 == 1 & x19_China == 1 & countrynewwb == "China" ~ 1,
                             i19 == 1 & countrynewwb == "China" ~ 0,
                             m19 == 1 ~ 0,
                             TRUE ~ NA),
         x19_any = case_when(i19 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1,
                             i19 == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1,
                             m19 == 1 & wp18175 == 1 ~ 1,
                             i19 == 1 ~ 0,
                             TRUE ~ NA), 
         
         # 2020
         x20_fi = case_when(i20 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1, # account at a fiancial institution OR have a debit card
                            i20 == 1 ~ 0,
                            TRUE ~ NA),
         x20_China = case_when(i20 == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1, # any wechat etc.
                               i20 == 1 & countrynewwb == "China" ~ 0,
                               TRUE ~ NA),
         x20_mob = case_when(m20 == 1 & wp18175 == 1 ~ 1,
                             i20 == 1 & x20_China == 1 & countrynewwb == "China" ~ 1,
                             i20 == 1 & countrynewwb == "China" ~ 0,
                             m20 == 1 ~ 0,
                             TRUE ~ NA),
         x20_any = case_when(i20 == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1,
                             m20 == 1 & wp18175 == 1 ~ 1,
                             i20 == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1,
                             i20 == 1 & countrynewwb == "China" ~ 0,
                             i20 == 1 ~ 0,
                             TRUE ~ NA),
         
         # 2022
         x22_fi = case_when(i22_s == 1 &  (wp15845 == 1 | wp15846 == 1) ~ 1, # account at a fiancial institution OR have a debit card
                            i22_s == 1 ~ 0,
                            TRUE ~ NA),
         x22_China = case_when(i22_s == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1, # any wechat etc.
                               i22_s == 1 & countrynewwb == "China" ~ 0,
                               TRUE ~ NA),
         x22_mob = case_when(m22_s == 1 & wp18175 == 1 ~ 1,
                             i22_s == 1 & x22_China == 1 & countrynewwb == "China" ~ 1,
                             m22_s == 1 ~ 0,
                             TRUE ~ NA),
         x22_mm_filq = case_when(m22_s == 1 & wp15162 == 1 ~ 1,
                                 m22_s == 1 ~ 0,
                                 TRUE ~ NA),
         x22_any = case_when(i22_s == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1,
                             i22_s == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1,
                             m22_s == 1 & wp18175 == 1 ~ 1,
                             i22_s == 1 ~ 0,
                             TRUE ~ NA),
         
         # 2023
         x23_fi = case_when(i23_s == 1 &  (wp15845 == 1 | wp15846 == 1) ~ 1, # account at a fiancial institution OR have a debit card
                            i23_s == 1 ~ 0,
                            TRUE ~ NA),
         x23_China = case_when(i23_s == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1, # any wechat etc.
                               i23_s == 1 & countrynewwb == "China" ~ 0,
                               TRUE ~ NA),
         x23_mob = case_when(m23_s == 1 & wp18175 == 1 ~ 1,
                             i23_s == 1 & x22_China == 1 & countrynewwb == "China" ~ 1,
                             m23_s == 1 ~ 0,
                             TRUE ~ NA),
         x23_mm_filq = case_when(m23_s == 1 & wp15162 == 1 ~ 1,
                                m23_s == 1 ~ 0,
                                TRUE ~ NA),
         x23_any = case_when(i23_s == 1 & (wp15845 == 1 | wp15846 == 1) ~ 1,
                             i23_s == 1 & wp20328 == 1 & countrynewwb == "China" ~ 1,
                             m23_s == 1 & wp18175 == 1 ~ 1,
                             i23_s == 1 ~ 0,
                             TRUE ~ NA))