
countries <- data %>%
  filter(group == "all") %>%
  filter(year %in% c(2024)) %>%
  filter(countrynewwb %in% c_region)%>%
  select(countrynewwb, year, fin24D_1, fin24B_less2weeks_climate,
         fin24B_about1month_climate,fin24B_about2month_climate,
         fin24B_more2month_climate) %>%
  mutate(total = fin24B_less2weeks_climate+ fin24B_about1month_climate+fin24B_about2month_climate+fin24B_more2month_climate)

data_Borrowing_last_income <- data %>%
  filter(group == "all") %>%
  filter(year %in% c(2024)) %>%
  filter(countrynewwb %in% c(countries$countrynewwb)) %>%
  select(countrynewwb, year, fin24D_1, fin24B_less2weeks_climate,
         fin24B_about1month_climate,fin24B_about2month_climate,
         fin24B_more2month_climate) %>%
  mutate(total = fin24B_less2weeks_climate+ fin24B_about1month_climate+fin24B_about2month_climate+fin24B_more2month_climate) %>%
  # filter(fin24D_1 >= 0.2) %>%
  filter(!is.na(fin24B_about2month_climate)) %>%
  na.omit() %>%
  gather(group, value,fin24B_less2weeks_climate, fin24B_about1month_climate, 
         fin24B_about2month_climate, fin24B_more2month_climate) %>%
  # filter(group %in% c("fin24B_less2weeks_climate", "fin24B_about1month_climate",
  #                     "fin24B_about2month_climate", "fin24B_more2month_climate")) %>%
  # Calculate percentage
  group_by(countrynewwb) %>%
  mutate(value = value / total * 100) %>%
  ungroup()


data_Borrowing_last_income <- data %>%
  filter(group == "all") %>%
  filter(year %in% c(2024)) %>%
  filter(countrynewwb %in% c(countries$countrynewwb)) %>%
  select(countrynewwb, year, fin24D_1, fin24B_less2weeks_climate,
         fin24B_about1month_climate, fin24B_about2month_climate,
         fin24B_more2month_climate) %>%
  mutate(total = fin24B_less2weeks_climate + fin24B_about1month_climate +
           fin24B_about2month_climate + fin24B_more2month_climate) %>%
  # filter(fin24D_1 >= 0.2) %>%
  filter(!is.na(fin24B_about2month_climate)) %>%
  na.omit() %>%
  gather(group, value, fin24B_less2weeks_climate, fin24B_about1month_climate, 
         fin24B_about2month_climate, fin24B_more2month_climate) %>%
  group_by(countrynewwb) %>%
  mutate(value = value / total * 100) %>%
  ungroup() %>%
  # Reorder the `group` factor
  mutate(group = factor(group, levels = c("fin24B_more2month_climate", 
                                          "fin24B_about2month_climate", 
                                          "fin24B_about1month_climate", 
                                          "fin24B_less2weeks_climate"))) 

# Check the number of unique countries in countrynewwb
length_unique_countries <- data_Borrowing_last_income  %>%
  summarise(unique_countries = n_distinct(countrynewwb)) %>%
  pull(unique_countries)

if (length_unique_countries < 8) {
  width_num <-8
  height_num <-4 # default setting as 8 countries
} else{
  # Every two country added ,width as 2, height as 1
  width_num <- 8 + floor((length_unique_countries - 1) / 4) * 2
  height_num <- 4 + floor((length_unique_countries - 1) / 4)
}

# print width and height as this round
cat("Width:", width_num, "\n")
cat("Height:", height_num, "\n")

unique_countries_list <- data_Borrowing_last_income %>%
  distinct(countrynewwb) %>%
  pull(countrynewwb)



data_Borrowing_last_income <- data_Borrowing_last_income %>%
  mutate(countrynewwb = recode(countrynewwb,
                               "East Asia & Pacific (excluding high income)" = "East Asia and Pacific",
                               "Europe & Central Asia (excluding high income)" = "Europe and Central Asia",
                               "Latin America & Caribbean (excluding high income)" = "Latin America and the Caribbean",
                               "Middle East & North Africa (excluding high income)" = "Middle East and North Africa",
                               "South Asia (excluding high income)" = "South Asia",
                               "Sub-Saharan Africa (excluding high income)" = "Sub-Saharan Africa"))

# Create the plot
ggplot(data_Borrowing_last_income, aes(x = factor(countrynewwb), y = value)) +
  geom_bar(aes(x = factor(countrynewwb),
               y = value,
               fill = factor(group, levels = c(
                 "fin24B_less2weeks_climate",  
                 "fin24B_about1month_climate", 
                 "fin24B_about2month_climate",  
                 "fin24B_more2month_climate"    
               ))), 
           stat = "identity", 
           position = "stack", 
           width = 0.7,
           color = "black") +
  
  scale_fill_manual(
    values = c(
      "fin24B_less2weeks_climate" = "#cccccc",  
      "fin24B_about1month_climate" = "#d8E157",
      "fin24B_about2month_climate" = "#5696D0",
      "fin24B_more2month_climate" = "#15AFB7"
    ),
    limits = c("fin24B_more2month_climate", 
               "fin24B_about2month_climate", 
               "fin24B_about1month_climate", 
               "fin24B_less2weeks_climate"),
    labels = c(
      "More than two months",
      "About two months",
      "About a month",
      "Less than two weeks"
    )
  ) +
  
  scale_x_discrete(labels = wrap_format(18)) +
  theme(
    # legend.position = "none",
    strip.placement = "outside",
    strip.text.y.left = element_text(angle = 0),
    strip.text.y = element_text(size = 16, family = "Nunito Sans"),
    panel.background = element_blank(),
    strip.background  = element_blank(),
    panel.grid.major.x = element_blank(),
    panel.grid.minor.x = element_blank(),
    panel.grid.major.y = element_blank(),
    panel.grid.minor.y = element_blank(),
    panel.border=element_blank(),
    #legend.position = "none",
    legend.title = element_blank(),
    axis.title.x = element_blank(),
    axis.title.y = element_blank(),
    axis.text.x = element_text( 
      family = "Nunito Sans",
      color = "black",
      size = 16),
    axis.text.y = element_text(family = "Nunito Sans", color = "black", size = 16),,
    axis.ticks.x = element_blank(),
    axis.ticks.y = element_line(),
    plot.subtitle = element_text(size = 16,
                                 family = "Nunito Sans"),
    plot.title = element_text(hjust = 0,
                              size = 16,
                              family = "Nunito Sans",
                              face = "bold"),
    plot.title.position = "plot",
    legend.text = element_text(#hjust = 0,
      size = 16,
      family = "Nunito Sans"),
    # legend.text.align = 0,
    legend.position ="bottom",
    legend.justification='center',
    legend.direction = "horizontal",
    plot.caption = element_text(hjust = 0,
                                size = 12,
                                vjust = 0,
                               family = "Nunito Sans"),
    strip.text.x = element_text(family = "Nunito Sans",
                                color = "black",
                                size = 16),
    plot.caption.position =  "plot") +
  guides(fill = guide_legend(nrow = 1, byrow = TRUE)) +
  labs(
    subtitle = "Adults (%), 2024",
    title = "The largest share of adults in low- and middle-income economies could cover more than two months of \nexpenses if they lost their main income source",
    caption = "Source: Global Findex 2025")

ggsave(
  filename = file.path(folder_path, ("3107_borrow_climate_last.png")),
  width = width_num+1,
  height = height_num+2,
  device = 'png',
  dpi = 120
)

