
mob <- data %>% filter(i24 == 1 & group == "all" & country_level == 1) %>%
  select(countrynewwb, con1_all) %>%
  rename(`% of adults with a mobile phone (age 15+)` = con1_all)

acc <- data %>% filter(i24 == 1 & group == "all" & country_level == 1) %>%
  select(countrynewwb, ts_account) %>%
  rename(`% of adults with an account (age 15+)` = ts_account)

mm_all <- data %>% filter(i24 == 1 & group == "all" & country_level == 1) %>%
  select(countrynewwb, ts_mobaccount) %>%
  rename(`% of adults with a mobile money account (age 15+)` = ts_mobaccount)

mm14 <- data %>% filter(i14 == 1 & regionwb24_hi == "Sub-Saharan Africa (excluding high income)") %>%
  select(year, countrynewwb, ts_mobaccount) %>%
  rename(`% of adults with a mobile money account (age 15+)` = ts_mobaccount)

mm24 <- data %>% filter(i24 == 1 & regionwb24_hi == "Sub-Saharan Africa (excluding high income)") %>%
  select(year, countrynewwb, ts_mobaccount) %>%
  rename(`% of adults with a mobile money account (age 15+)` = ts_mobaccount)

sav <- data %>% filter(i24 == 1 & group == "all" & country_level == 1) %>%
  select(countrynewwb, ts_savfor_fi_mm)

bor <- data %>% filter(i24 == 1 & group == "all" & country_level == 1) %>%
  select(countrynewwb, ts_borrfor_fi_cc_mm)

dig <- data %>% filter(i24 == 1 & group == "all" & country_level == 1) %>%
  select(countrynewwb, ts_digpay_imputed)


# Step 1: Create your named list of data frames
sheet_data <- list(
  "1.1.1" = mob,
  "2.1.1" = acc,
  "2.1.2" = mm_all,
  "2.1.3a" = mm14,
  "2.1.3b" = mm24,
  "3.1.1" = sav,
  "3.2.1" = bor,
  "3.3.1" = dig
)


install.packages("openxlsx")
library(openxlsx)
# Step 2: Create workbook
wb <- createWorkbook()

# Step 3: Loop over the list and add worksheets
for (sheet_name in names(sheet_data)) {
  addWorksheet(wb, sheet_name)
  writeData(wb, sheet = sheet_name, sheet_data[[sheet_name]])
}

# Step 4: Save the workbook
saveWorkbook(wb, 
             filename = file.path(folder_path, ("map_data.xlsx")),
             overwrite = TRUE)

